<template>
  <ObForm
    @submit="beforeSubmit"
    :form-data="formData"
    :form-model="formModel"
    :is-show-controls="isLoaded"
    :is-read-only="isRegistered"
    :is-submit-disabled="submitButtonState"
    ok-text="Добавить"
    cancel-text="Отменить"
  >
    <ObLoader
      v-if="!isLoaded"
      class="modal-loader"
    />

    <template v-else-if="formData.props">
      <OwnerField @input="changeOwner" />

      <div class="bottom-30">
        <ObSelect
          :required="true"
          :is-search="true"
          :items="countries"
          :is-auto-complete="false"
          v-model="formData.countryCode"
          label="Страна регистрации"
          value-exp="countryCode"
          display-exp="titleWording"
          class="bottom-20"
        />

        <ObCheckbox
          v-model="isGovernmentRegnum"
          label="Госномер РФ"
          class="bottom-10"
        />

        <div class="inputs-group">
          <ObInput
            v-model="formData.props.regnum"
            :mask="isGovernmentRegnum ? regnumMask : ''"
            :required="true"
            :mask-tokens="regnumMaskTokens"
            property="props.regnum"
            placeholder="Укажите"
            label="Регистрационный номер"
          />

          <ObInput
            label="Макс. грузопод-ть"
            placeholder="20"
            sub-title="т"
            type="number:strict"
            property="props.payload_max"
            v-model="formData.props.payload_max"
            :required="true"
            @input="checkLength($event)"
          />
        </div>

        <div
          v-if="!isRegistered"
          class="text-description"
        >
          Марка, цвет, год выпуска и другие данные ТС будут добавлены
          в систему после распознания приложенных документов.
        </div>
      </div>

      <ObAlert
        v-if="isRegistered"
        :hide-close-button="true"
        icon="checked"
        theme="warning"
        text="ТС с таким номером уже зарегистрировано, но не активировано"
      />

      <template v-else>
        <div class="bottom-30">
          <h3 class="subtitle">Право владения</h3>

          <ObControlGroup
            :items="ownershipForms"
            v-model="selectedOwnershipForm"
            theme="light"
            height="slim"
          />

          <div class="row">
            <div class="col-xs-4">
              <ObCheckbox
                label="Находится в залоге"
                v-model="formData.props.vehicle_in_pledge"
              />
            </div>

            <div class="col-xs-5">
              <ObCheckbox
                label="ТС застраховано КАСКО"
                v-model="formData.props.has_casco_insurance"
              />
            </div>
          </div>

          <div
            v-if="selectedOwnershipForm === rentOwnershipFormCode"
            class="rent-scan"
          >
            <div class="uploader-label">
              Загрузите скан договора аренды <span class="-light-raspberry-red">*</span>
            </div>

            <ObUploader
              :upload-method="uploadMethod"
              :upload-options="getUploadOptions()"
              @process-start="onFilesProcessStart"
              @change="onUpload('RENT', $event)"
              class="uploader"
            />
          </div>
        </div>

        <ObSelect
          :items="bodyTypes"
          :required="true"
          v-model="formData.typeUuid"
          label="Тип кузова"
          placeholder="Выберите из списка"
          class="bottom-30"
        />

        <div class="bottom-30">
          <h3 class="subtitle">Погрузка</h3>

          <ObCheckbox
            v-for="item in loadingMethods"
            :key="item.uuid"
            :label="item.title"
            v-model="item.isChecked"
            class="loading-type-checkbox"
          />
        </div>

        <div class="bottom-30">
          <h3 class="subtitle">Оснащение ТС</h3>

          <div class="text-description bottom-10">
            Укажите, чем оснащено ТС. Это позволит более точно подбирать заказы для него
          </div>

          <ObSelect
            :items="builtInEquipment"
            :is-dropdown="true"
            v-model="formData.props.built_in_equipment"
            label="Оснащение ТС"
            placeholder="Выберите один или несколько вариантов"
          />
        </div>

        <Documents
          :links="formData.links"
          @upload="onUpload"
        />
      </template>
    </template>
  </ObForm>
</template>

<script>
  import addFormMixin from './mixins/addFormMixin'
  import { required } from 'vuelidate/lib/validators'
  import api from '@/api'

  export default {
    name: 'AddResourceWagon',
    mixins: [
      addFormMixin
    ],
    computed: {
      formModel () {
        const resultObject = Object.assign(this.commonFormModel, {
          typeUuid: {
            validator: {
              required
            }
          }
        })

        resultObject.props.nested_fields = Object.assign(this.commonFormModel.props.nested_fields, {
          built_in_equipment: {
            value: []
          }
        })

        return resultObject
      }
    },
    data () {
      return {
        resourceName: 'Van',
        loadingMethods: [],
        bodyTypes: [],
        builtInEquipment: []
      }
    },
    async mounted () {
      await this.getSpeciesUuid()

      this.bodyTypes = await api.resources.getResourceTypesDropdownBySpecies(this.speciesUuid)

      const { loadingMethods } = await api.resources.getLoadingMethods()
      this.loadingMethods = loadingMethods

      this.builtInEquipment = await api.services.getServiceRequirements()

      await this.getOwnershipForms()

      this.isLoaded = true
    },
    methods: {
      beforeSubmit () {
        this.formData.props.loading_method = this.loadingMethods.reduce((methods, item) => {
          if (item.isChecked) {
            methods.push(item.uuid)
          }

          return methods
        }, [])

        this.onSubmit()
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "./styles/addFormStyles";
</style>